Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 355135)
+++ channels/chan_sip.c	(working copy)
@@ -16650,12 +16650,10 @@
 	const char *id;
 	char idtext[256] = "";
 	int realtimepeers;
-	int objcount = ao2_container_count(peers);
 	struct sip_peer **peerarray;
 	int k;
 
 	realtimepeers = ast_check_realtime("sippeers");
-	peerarray = ast_calloc(sizeof(struct sip_peer *), objcount);
 
 	if (s) {	/* Manager - get ActionID */
 		id = astman_get_header(m, "ActionID");
@@ -16680,7 +16678,10 @@
 	if (!s) /* Normal list */
 		ast_cli(fd, FORMAT2, "Name/username", "Host", "Dyn", "Forcerport", "ACL", "Port", "Status", (realtimepeers ? "Realtime" : ""));
 
+	ao2_lock(peers);
+	peerarray = ast_calloc(sizeof(struct sip_peer *), ao2_container_count(peers));
 	i = ao2_iterator_init(peers, 0);
+	ao2_unlock(peers);
 	while ((peer = ao2_t_iterator_next(&i, "iterate thru peers table"))) {
 		ao2_lock(peer);
 
@@ -16691,7 +16692,6 @@
 		}
 
 		if (havepattern && regexec(&regexbuf, peer->name, 0, NULL, 0)) {
-			objcount--;
 			ao2_unlock(peer);
 			unref_peer(peer, "toss iterator peer ptr before continue");
 			continue;
Index: main/astobj2.c
===================================================================
--- main/astobj2.c	(revision 355135)
+++ main/astobj2.c	(working copy)
@@ -807,6 +807,7 @@
 {
 	struct ao2_iterator a = {
 		.c = c,
+		.c_version = c->version,
 		.flags = flags
 	};
 
